Subject: Re: Rust building

From: John Goerzen <[email-masked]>
Date: Tue, 14 Jun 2022 08:59:37 -0500

On Fri, Jun 10 2022, Sergey Matveev wrote:

>>https://rustc-dev-guide.rust-lang.org/building/how-to-build-and-run.html
>
> Tried it now. It went downloading
> https://static.rust-lang.org/dist/2022-05-20/rust-std-beta-x86_64-unknown-freebsd.tar.xz
>

I don't want to derail too much, but there is a FreeBSD port of Rust,
and a team around it in FreeBSD:

https://wiki.freebsd.org/Rust

> without any questions or warnings, trying to run it after. No
> information how you can build that binary by self. I know that Rust 1.23
> is built using 1.22, that was built with 1.21, and so on. If there were
> any clear path how you can make all that path to the code you can build
> from native OS'es C-compiler, then it will be ok. But there is no

On the one hand, I can see your point here.  Many (definitely not all)
languages have a compiler or interpreter implemented in C.  So we can
expect to be able to begin with binaries for cc, as, ld, and friends,
and then from that, build other things.

On the other hand, I think that Rust (and also Go in a different way)
make a pretty credible case that the era of C dominance ought to be
coming to an end before long.  Already one can write device drivers for
both Linux and FreeBSD in Rust.  So, I don't want to say "has a C
implementation" ought to be a requirement for a language I use

More broadly, I don't want to "bless" C as somehow special.  "Well it's
OK if we have to download a distribution-supplied precompiled binary of
cc, but not other languages."  If cc can be written in C, why not rustc
in Rust?

- John